var EventEmitter = require('events').EventEmitter;
var inherits = require('inherits');
var vkey = require('vkey');

module.exports = Keyboard;
inherits(Keyboard, EventEmitter);

function Keyboard(game){
  this.game = game || {};
  this.keysDown = {};
  this.initializeListeners();
}

Keyboard.prototype.initializeListeners = function(){
  var self = this;

  document.addEventListener('keydown', function(e){
    self.emit('keydown', vkey[e.keyCode]);
    self.keysDown[vkey[e.keyCode]] = true;

    if (e.keyCode === 40 || e.keyCode === 38 || e.keyCode === 37 || e.keyCode === 39 || e.keyCode === 32) {
      e.preventDefault();
    }
  }, false);

  document.addEventListener('keyup', function(e){
    self.emit('keyup', vkey[e.keyCode]);
    delete self.keysDown[vkey[e.keyCode]];
  }, false);
};